
	.ifndef	PERFORMANCECOUNTERI
	.def	PERFORMANCECOUNTERI
	
	;defines
	
	.def	pfcInstCacheHitCnt		4
	.def	pfcFetchReloadCycleCnt		5 
	.def	pfcScoreStallCnt		6 
	.def	pfcExecuteStallCnt		7 
	.def	pfcDispatchMergeStallCnt	8 
	.def	pfcDBufferHitCnt		9 
	.def	pfcDBufferMissCnt		10
	.def	pfcSoftTriggerCounter		11
	
	.def 	pfcConfig			4
	
	;macros
	
	.macro	enablePerformanceCounter(unused)
	
		move	hold,6
		sssr	last,pfcConfig
		
	.endmacro
	
	.macro	disablePerformanceCounter(unused)
	
		move	hold,4
		sssr	last,pfcConfig
		
	.endmacro
	
	.macro	resetPerformanceCounter(unused)
	
		move	hold,1
		sssr	last,pfcConfig
		
	.endmacro
	
	.macro	softTriggerPerformanceCounter(unused)
	
		move	hold,$10
		sssr	last,pfcConfig
		
	.endmacro
	
	.endif
	