
	;this version is only sd card bootable	
	
; sdram
;
;	$0000 0000 	frame buffer 0
;	$0001 4a78	frame buffer 1
;	$0002 94f0	rom mirror (star at $0001 7f68)  font colored
;	$0002 c3f0	rom mirror bobs
;
	
	;sd header is placed here
	
	.incdir	"F:\git\goldmomo_endlos\assembler_files\ucore\"
	.include "boot_level_sdHeader.s"

	;start at address 32 here
	
	;read sdcard to sram
	
	movei	r0,startBlock
	nop
	moveih	r0,>startBlock
	nop
	rqldi	r0,0	;low
	rqldi	r0,1	;high
	nop
	ld	r2
	ld	r3
	
	addi	r2,64	;64 blocks offset (ucore code/data)
	addtqi	r3,r3,0
	
	;read blocks

	movei	r0,$f0
	movei	r1,$02
	moveih	r0,$94
	moveih	r1,$d0		;r1:r0 = $d002 94f0 (dest start)
	
	movei	r6,sdCardReadBlocks
	nop
	moveih	r6,>sdCardReadBlocks
	
	gpci	r7,2		;
	jmpi	r6,0
	movei	r4,$8e		;399blocks-1	delay slot
	nop			;delay slot
	moveih	r4,$1		;delay slot
	nop			;delay slot
	
;***********************************************************************
;* real code
;***********************************************************************
	
	.include 	"spacePilot_core.s"	
	
;*********************************************************************
;* functions
;*********************************************************************	
	
	.include	"components\sdCardLoader.s"
		
;*********************************************************************
;* sd data after code segment
;*********************************************************************		
		
	;gfx
		
	.org	16384
	.incdir "F:\git\goldmomo_endlos\gfx"
	.incbin	"topaz_8x16_colored.dat.raw"
	.incbin	"Spaceship_sprites_by_arboris_fixed_256x352x1555.dat.raw"
	
				