﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using xcore_tools.Data;

namespace ucore_assembler_library
{
    public interface IOpcode<T>
    {

        bool parse_check(Line currentLine);

        T generate();
        string trace(bool longFormat = true);
        Labels labelDictonary
        {
            get;
            set;
        }
        bool noData();
        bool checkResolveImm();
        
        uint pc
        {
            get;
            set;
        }

        // binary extension

        bool isBinary
        {
            get;
        }

        uint lengthBinary
        {
            get;
        }

        UInt16[] dataBinary
        {
            get;
        }
    }
}
