﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.extMemory.SDCard
{
    public class SDClk : IClocked
    {
        public SDClk()
        {
            reset();   
        }

        public UInt16 prg_clk_msk
        {
            get { return m_prg_clk_msk; }
            set { m_prg_clk_msk = value; }
        }

        public UInt16 prg_clk_edge_cmp_down
	    {
            get { return m_prg_clk_edge_cmp_down; }
            set { m_prg_clk_edge_cmp_down = value; }
        }

        public UInt16 prg_clk_edge_cmp_up		
        {
            get { return m_prg_clk_edge_cmp_up; }
            set { m_prg_clk_edge_cmp_up = value; }
        }

        public UInt16 prg_clk_write_edge_cmp	
        {
            get { return m_prg_clk_write_edge_cmp; }
            set { m_prg_clk_write_edge_cmp = value; }
        }

        public UInt16 prg_clk_read_edge_cmp
        {
            get { return m_prg_clk_read_edge_cmp; }
            set { m_prg_clk_read_edge_cmp = value; }
        }

        UInt16 m_prg_clk_msk;			
        UInt16 m_prg_clk_edge_cmp_down;	
        UInt16 m_prg_clk_edge_cmp_up;		
        UInt16 m_prg_clk_write_edge_cmp;	
        UInt16 m_prg_clk_read_edge_cmp;

        public void reset()
        {
            /* default setup */

            prg_clk_msk = 0x01ff;
            prg_clk_edge_cmp_down = 0x0000;
            prg_clk_edge_cmp_up = 0x0100;
            prg_clk_write_edge_cmp = 0x0080;
            prg_clk_read_edge_cmp = 0x01bf;
        }

        public void step()
        {
            throw new NotImplementedException();
        }
    }
}
