﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core
{
    class hcore_definitions
    {
    }

    public enum hopcode_t
    {
        hope_move,
        hope_moveh,
        hope_add,
        hope_sub,
        hope_cmplo,
        hope_cmplos,
        hope_cmple,
        hope_cmples,
        hope_cmpeq,
        hope_jmp,
        hope_br,
        hope_gpc,
        hope_and,
        hope_or,
        hope_xor,
        hope_bic,
        hope_mul,
        hope_mulh,
        hope_lsr,
        hope_lsl,
        hope_asr,
        hope_st,
        hope_stw,
        hope_uexec,
        hope_idle,
        hope_dump,
        hope_nop,
        hope_ld,
        hope_ldw,
        hope_ldws,
        hope_gssr,
        hope_sssr,
        hope_uexecs,
        hope_udivinit,
        hope_udivstep,
        hope_udivgrem,
        hope_rsub,
        hope_stc,
        hope_ldc,
        hope_roe,

        // internal

        hope_skip,
        hope_illegal,
      

    }

    public enum hcondition_t
    {
	    hcc_ever,
	    hcc_ts,
	    hcc_tc,
	    hcc_never
    }
}
