﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace xcore_tools.Common
{
    public class Immediate
    {
        public static int translate(int din, int widthBits, bool signed, bool cut,bool noTest = false)
        {

            int cutMask = (1 << widthBits) - 1;
            int max = signed ? (((1 << widthBits) - 1) / 2):(1 << widthBits) - 1;
            int min = signed ? -((1 << widthBits) / 2) : 0;
         
            if (cut)
            {
                din = din & cutMask;
            }           

            if (din < min || din > max)
            {
                throw new Exception(String.Format("Illegal immediate value  '" + din + "' type {0} range is ({1} .. {2})", signed ? "signed" : "unsigned", min, max));
            }
            
            return din;
        }
    }
}
