library ieee;
use work.hcore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity thread_ctrl is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic
				
				-- requester / accept
				
			--	idles				: in idles_t;
		--		requester		: in thread_requests_t;
			--	accepteds		: out thread_accepteds_t							
		);
end entity;

architecture rtl of thread_ctrl is

type ctrlState_t is
	(
		CS_WAIT,
		CS_ALLOC,
		CS_WAIT_DEALOC
	);
	
signal ctrlState : ctrlState_t := CS_WAIT;	



begin
/*
	process(clk)
		variable idleCount : integer range 0 to hcore_count-1;
		variable sender_number		: integer range 0 to hcore_count-1;
		variable used_cores 		: integer range 0 to hcore_count-1;
		variable current_core		: integer range 0 to hcore_count-1;
		variable handover_address 	: std_logic_vector(31 downto 0);	-- 32 
		variable jump_address		: std_logic_vector(31 downto 0);	-- 32 
	begin
		if rising_edge(clk) then
			if reset = '1' then
				ctrlState <= CS_WAIT;
			else
			
				-- defaults
				
				for I in 0 to hcore_count-1 loop
					accepteds(I).ready <= '0';
				end loop;
				
				--
			
				case ctrlState is
					
					-- wait for request from any core				
				
					when CS_WAIT =>
					
						-- count idles
						
						idleCount := 1;
						
						for I in 0 to hcore_count-1 loop
							if idles(I) = '1' then
								idleCount := idleCount + 1;
							end if;
						end loop;
					
						-- check request for threads
					
						for I in 0 to hcore_count-1 loop
							if requester(I).request = '1' then
									sender_number	:= I;	-- store sender (is also a reciver)
							
									used_cores 		:= requester(I).max_cores;
									
									if idleCount < used_cores then
										used_cores := idleCount;
									end if;
									
									handover_address 	:= requester(I).handover_address;
									jump_address 		:= requester(I).jump_address;
									
									ctrlState <= CS_ALLOC;
								exit;	-- stop loop
							end if;							
						end loop;										
						
					-- send all idle cores data (requester too)	
						
					when CS_ALLOC =>
						
						current_core := 0; 
						
						for I in 0 to hcore_count-1 loop
						
							accepteds(I).max_cores			<= used_cores;
							accepteds(I).current_core_number 	<= current_core;
							accepteds(I).handover_address 		<= handover_address;
							accepteds(I).jump_address		<= jump_address;
						
							if idles(I) = '1' or sender_number = I then															
								current_core := current_core + 1;								
								accepteds(I).ready <= '1';
							end if;
						end loop;
						
						ctrlState <= CS_WAIT_DEALOC;
					
					-- wait until requester will set request to 0
					
					when CS_WAIT_DEALOC =>								
					
						if requester(sender_number).request = '0' then
							ctrlState <= CS_WAIT;
						else
							ctrlState <= CS_WAIT_DEALOC;
						end if;
					
				end case;
			end if;
		end if;
	end process;
	*/
end rtl;
