library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sdData_io is
		port 
		(
				-- global

				clk					: in std_logic;
				reset					: in std_logic;	

				-- SDCARD 
				
				SD_CLK				: out std_logic;
				SD_DAT				: inout std_logic_vector(3 downto 0);
				
				-- clk in
				
				clk_write_edge		: in std_logic;
				clk_read_edge		: in std_logic;
				
				-- 
				
				fifo_D1_in_usage		: out std_logic_vector (12 DOWNTO 0);
				fifo_D2_in_usage		: out std_logic_vector (12 DOWNTO 0);
				fifo_D3_in_usage		: out std_logic_vector (12 DOWNTO 0);
				fifo_D4_in_usage		: out std_logic_vector (12 DOWNTO 0);
				
				data_in_cnt			: in integer range 0 to 8191; -- cnt + 1
				
				-- send
				
				dummy	: in std_logic
				
				
		);
end entity;

architecture rtl of sdData_io is

begin
	
	
end rtl;
