library ieee;
use work.ucore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity shifts is
		port 
		(			
				-- data in
				
				b					: in std_logic_vector(15 downto 0);
				a					: in std_logic_vector(15 downto 0);
							
				-- data out
				
				lsr_res			: out std_logic_vector(15 downto 0);
				asr_res			: out std_logic_vector(15 downto 0)
			
															
		);
end entity;



architecture rtl of shifts is
		
begin

	lsr_res	<= SHR(b,a(3 downto 0));
	asr_res  <= std_logic_vector(SHR(signed(b),unsigned(a(3 downto 0))));
					
end rtl;
