## Generated SDC file "ucore_test.sdc"

## Copyright (C) 1991-2013 Altera Corporation
## Your use of Altera Corporation's design tools, logic functions 
## and other software and tools, and its AMPP partner logic 
## functions, and any output files from any of the foregoing 
## (including device programming or simulation files), and any 
## associated documentation or information are expressly subject 
## to the terms and conditions of the Altera Program License 
## Subscription Agreement, Altera MegaCore Function License 
## Agreement, or other applicable license agreement, including, 
## without limitation, that your use is for the sole purpose of 
## programming logic devices manufactured by Altera and sold by 
## Altera or its authorized distributors.  Please refer to the 
## applicable agreement for further details.


## VENDOR  "Altera"
## PROGRAM "Quartus II"
## VERSION "Version 13.1.1 Build 166 11/26/2013 SJ Web Edition"

## DATE    "Sat Jan 11 20:22:44 2014"

##
## DEVICE  "EP4CE115F29C7"
##


#**************************************************************
# Time Information
#**************************************************************

set_time_format -unit ns -decimal_places 3



#**************************************************************
# Create Clock
#**************************************************************

create_clock -name {CLOCK2_50} -period 20.000 -waveform { 0.000 10.000 } [get_ports {CLOCK2_50}]
create_clock -name {CLOCK_50} -period 20.000 -waveform { 0.000 10.000 } [get_ports {CLOCK_50}]


#**************************************************************
# Create Generated Clock
#**************************************************************

create_generated_clock -name {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]} -source [get_pins {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 5 -divide_by 2 -master_clock {CLOCK_50} [get_pins {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] 
create_generated_clock -name {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[1]} -source [get_pins {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 5 -divide_by 2 -phase -135.0 -master_clock {CLOCK_50} [get_pins {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[1]}] 
create_generated_clock -name {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]} -source [get_pins {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 115 -divide_by 54 -master_clock {CLOCK2_50} [get_pins {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] 
create_generated_clock -name {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]} -source [get_pins {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 115 -divide_by 312 -master_clock {CLOCK2_50} [get_pins {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] 
create_generated_clock -name {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]} -source [get_pins {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 2 -master_clock {CLOCK_50} [get_pins {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] 
create_generated_clock -name {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]} -source [get_pins {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|inclk[0]}] -duty_cycle 50.000 -multiply_by 12 -divide_by 5 -master_clock {CLOCK_50} [get_pins {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] 


#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************

set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.160  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.160  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.020  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.160  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}]  0.160  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.150  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.150  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.160  
set_clock_uncertainty -rise_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.160  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -rise_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.160  
set_clock_uncertainty -fall_from [get_clocks {\pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0]}] -fall_to [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[1]}]  0.160  


#**************************************************************
# Set Input Delay
#**************************************************************



#**************************************************************
# Set Output Delay
#**************************************************************



#**************************************************************
# Set Clock Groups
#**************************************************************



#**************************************************************
# Set False Path
#**************************************************************

#**************************************************************
# Set Multicycle Path
#**************************************************************



#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************

#**************************************************************
# Constraints
#**************************************************************

# HEX LEDG LEDR 

set_false_path -to [get_ports {HEX0[*] LEDG[*] LEDR[*] }]

# SW KEY 

set_false_path -from [get_ports {SW[*] KEY[*]}]

# LCD

set_false_path -to [get_ports {LCD_BLON LCD_DATA[*] LCD_EN LCD_ON LCD_RS LCD_RW}]
set_false_path -from [get_ports {LCD_DATA[*]}]

# PS2

set_false_path -to 	[get_ports {PS2_CLK PS2_CLK2 PS2_DAT PS2_DAT2 }]
set_false_path -from 	[get_ports {PS2_CLK PS2_CLK2 PS2_DAT PS2_DAT2 }]	

# I2c EEPROM / AUDIO

set_false_path -to 	[get_ports {EEP_I2C_SCLK EEP_I2C_SDAT I2C_SCLK I2C_SDAT}]
set_false_path -from 	[get_ports {EEP_I2C_SCLK EEP_I2C_SDAT I2C_SCLK I2C_SDAT}]

# SDRAM

#note -3ns delay (extra clk for sdram)

set_input_delay 	-clock { \pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0] } -max [expr 5.4 + 0.6 - 3]  [get_ports {DRAM_DQ[*]}]
set_input_delay 	-clock { \pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0] } -min [expr 2.7 - 0.4 - 3]  [get_ports {DRAM_DQ[*]}]
set_output_delay  	-clock { \pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0] } -max [expr 1.5 + 0.6  - 3] [get_ports {DRAM_DQ[*] DRAM_ADDR[*] DRAM_BA[*] DRAM_CAS_N DRAM_CKE DRAM_CS_N DRAM_DQM[*] DRAM_RAS_N DRAM_WE_N}]
set_output_delay  	-clock { \pll_block:cgen_sdram|altpll_component|auto_generated|pll1|clk[0] } -min [expr -0.8 + 0.4 - 3] [get_ports {DRAM_DQ[*] DRAM_ADDR[*] DRAM_BA[*] DRAM_CAS_N DRAM_CKE DRAM_CS_N DRAM_DQM[*] DRAM_RAS_N DRAM_WE_N}]

# SRAM (FIXME)

set_max_skew -from [get_clocks {\pll_block:cgen_100Mhz|altpll_component|auto_generated|pll1|clk[0]}] -to [get_ports {SRAM_*}] 1.200 -include { input_delay output_delay }


# VGA

#set_output_delay 	-clock { \pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0] } -max [expr  1.5 + 0.6 ] [get_ports {VGA_B[*] VGA_BLANK_N VGA_G[*] VGA_HS VGA_R[*] VGA_SYNC_N VGA_VS}]
#set_output_delay 	-clock { \pll_block:cgen_ucore_uctrl_and_audio|altpll_component|auto_generated|pll1|clk[0] } -min [expr -0.2 + 0.4 ] [get_ports {VGA_B[*] VGA_BLANK_N VGA_G[*] VGA_HS VGA_R[*] VGA_SYNC_N VGA_VS}]

# AUDIO ??

# SDCARD ??

# SMA CLK not USED

set_false_path -from 	[get_ports {SMA_CLKIN}]
set_false_path -to 	[get_ports {SMA_CLKOUT}]

# EX_IO not USED

set_false_path -from 	[get_ports {EX_IO[*]}]
set_false_path -to 	[get_ports {EX_IO[*]}]

# UART not USED

set_false_path -to 	[get_ports {UART_CTS UART_TXD}]
set_false_path -from 	[get_ports {UART_RTS UART_RXD}]

# GPIO not USED

set_false_path -to 	[get_ports {GPIO[*]}]
set_false_path -from 	[get_ports {GPIO[*]}]

# HSMC not USED

set_false_path -from 	[get_ports {HSMC_CLKIN_N1 HSMC_CLKIN_N2 HSMC_CLKIN_P1 HSMC_CLKIN_P2 HSMC_CLKIN0 HSMC_D[*] HSMC_RX_D_N[*] HSMC_RX_D_P[*] HSMC_TX_D_N[*] HSMC_TX_D_P[*]}]
set_false_path -to 	[get_ports {HSMC_CLKOUT_N1 HSMC_CLKOUT_N2 HSMC_CLKOUT_P1 HSMC_CLKOUT_P2 HSMC_CLKOUT0 HSMC_D[*] HSMC_RX_D_N[*]	HSMC_RX_D_P[*] HSMC_TX_D_N[*]	HSMC_TX_D_P[*]}]
	
# IR not USED

set_false_path -from 	[get_ports {IRDA_RXD}]
