
	.ifndef	UCTRLPORTI
	.def	UCTRLPORTI
	
	;functions
	
	.def	upfNop		0 
	.def	upfSetparam     1 
	.def	upfGetparam     2 
	.def	upfCall         3 
	.def	upfSemst        4
	.def	upfSemld        5
	.def	upfSeminc       6
	.def	upfSemdec       7
	.def	upfAllocsem     8
	.def	upfFreesem      9
	
	;call sub functions
	
	.def	upfCallSubNop        0
	.def	upfCallSubSetLed     1
	.def	upfCallSubUCtrlWrite 2 
	.def	upfCallSubUCtrlRead  3 
	
	;macros
	
	.macro	ucpSetParam(paramPos,paramValue)
	
		move	hold,paramPos
		lsl	hold,last,8	;PPFF
		or	hold,last,upfSetparam
		uexec	last,paramValue
		
	.endmacro
	
	.macro	ucpCall(functionId)
	
		move	hold,upfCall	
		uexec	last,functionId	
		
	.endmacro
	
	.macro	ucpCallReturn(returnReg,functionId)
	
		move	hold,upfCall	
		uexecs	returnReg,last,functionId	
		
	.endmacro
	
	.endif
	