print "\n-> Start build\n\n"

cpuArchitecture = ENV['PROCESSOR_ARCHITECTURE']
prgFilesPath = ""

if cpuArchitecture == "AMD64" 
	prgFilesPath = ENV['ProgramFiles(x86)']
elsif cpuArchitecture == "x86"
	prgFilesPath = ENV['ProgramFiles']
else
	print "Unknown CPU Architecture, stop build\n"
	exit
end

msBuildPath = prgFilesPath + "\\MSBuild\\12.0\\bin\\msbuild.exe"
currentDir    = Dir.new(".")

print " CPU Architecture       = '" + cpuArchitecture + "'\n"
print " Program files location = '" + prgFilesPath + "'\n"
print " MSBuild location       = '" + msBuildPath + "'\n"

print " Current directory      = '" + currentDir.path + "'\n\n"

Dir.glob("*.sln") {|solution| 
print " start release build of '#{solution}"  + "'\n"
system("\"#{msBuildPath}\" #{solution} /t:Rebuild /p:Configuration=Release\n")
print " start debug build of '#{solution}"  + "'\n"
system("\"#{msBuildPath}\" #{solution} /t:Rebuild /p:Configuration=Debug\n")
}

print "\nFinish build <-\n"

