﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.stages.execute_extensions
{
    public class l2d_s0_out_s1_in : IStageSignals<l2d_s0_out_s1_in>
    {
        public UInt32 x;
        public UInt32 y;
        public bool en_out;

        public void reset()
        {

        }

        public void copy(ref l2d_s0_out_s1_in dout)
        {
            dout.x = x;
            dout.y = y;
            dout.en_out = en_out;
        }

        public string trace()
        {
            return "";
        }
    }

    public class l2d_s1_out_s2_in : IStageSignals<l2d_s1_out_s2_in>
    {
        public UInt32 x;
        public UInt32 y;
        public bool en_out;

        public void reset()
        {
                
        }

        public void copy(ref l2d_s1_out_s2_in dout)
        {
            dout.x = x;
            dout.y = y;
            dout.en_out = en_out;
        }

        public string trace()
        {
            return "";
        }
    }

    public class l2d_s2_out : IStageSignals<l2d_s2_out>
    {
        public UInt32 dadr;

        public void reset()
        {
               
        }

        public void copy(ref l2d_s2_out dout)
        {
            dout.dadr = dadr;
        }

        public string trace()
        {
            return "";
        }

           
    }
}
