﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.stages;
using ucore_emulator.core.components.stages_hcore;

namespace ucore_emulator.core.stages_hcore
{
    class s1_score : IStage
    {
        public void reset()
        {
           
        }

        public hc_s1_out_s2_in dataOut
        {
            get { return m_out; }
        }

        hc_s1_out_s2_in m_out = new hc_s1_out_s2_in();

        internal void process(components.stages_hcore.hc_s0_out_s1_in din, out components.stages_hcore.hc_s1_out_s2_in dout)
        {
            // this is done in readreg in SW not equal to HW 

            dout = m_out;
            dout.data_in = din.data;
            dout.debug_pc = din.address;
        }
    }
}
