﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using xcore_tools;
using ucore_emulator.core.components.stages;

namespace ucore_emulator.core.components.stages_hcore
{
    class s5_merge : IStage, IPrint
    {
        IPrint m_iprint;
        hDCache m_dcache;

        hc_s5_out_s6_in m_out = new hc_s5_out_s6_in();

        public s5_merge(IPrint iprint,hDCache dcache)
        {
            m_iprint = iprint;
            m_dcache = dcache;
        }

        public void reset()
        {
           
        }

        internal void process(components.stages_hcore.hc_s4_out_s5_in din,out hc_s5_out_s6_in dout)
        {
            dout = m_out;
            dout.pc_out = din.pc_out;
            dout.rc = din.rc;
            dout.rc_data = din.rc_data;
            dout.rc_unlock = din.rc_unlock;
            dout.rc_we = din.rc_we;
        }

        public void print(string txt)
        {
           
        }

        public void dprint(string txt)
        {
            
        }
    }
}
