﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components
{
    public class ucore_definitions
    {
    }

    public enum opcode_t
    {
        ope_movei,
	    ope_moveih,
	    ope_addi,
	    ope_subi,
	    ope_lsri,
	    ope_asri,
	    ope_muli,
	    ope_cmpeqi,
	    ope_cmploi,
	    ope_cmplosi,
	    ope_gpci,
	    ope_jmpi,
	    ope_extri,
	    ope_add,
	    ope_sub,
	    ope_lsr,
	    ope_asr,
	    ope_mul,
	    ope_cmpeq,
	    ope_cmplo,
	    ope_cmplos,
	    ope_movets,
	    ope_and,
	    ope_or,
	    ope_xor,
	    ope_bic,
	    ope_addqi,
	    ope_subqi,
	    ope_lsrqi,
	    ope_asrqi,
	    ope_mulqi,
	    ope_addtqi,
	    ope_subtqi,
        ope_edrqldi,
	    ope_ld_pop,
        ope_poparqp,
	    ope_st,
        ope_stinc,
        ope_bffo,
        ope_bset,
        ope_bclr,
        ope_cmple,
        ope_cmples,
        ope_extb,
        ope_stwo,
        ope_andts,
        ope_orts,
        ope_xorts,
        ope_bicts,
        ope_lsrts,
        ope_asrts,
        ope_mults,
        ope_mulsts,
	    ope_swptc,
	    ope_push,
	    ope_rqldi,
        ope_rqld,
	    ope_br,
	    ope_brts,
	    ope_brtc,
	    ope_rqpop,
	    ope_cli,
	    ope_sei,
	    ope_rti,
	    ope_nop,
        ope_dump,
        ope_addt,
        ope_subt,
	    ope_illegal,
        ope_gmulhi,
	    ope_espage,
	    ope_eld,
	    ope_est,
        ope_getssr,
        ope_setssr,
	    ope_erqldi,
        ope_ssto,	  
	    ope_epushsadrl,
	    ope_epushsadrh,
	    ope_epopsadrl,
	    ope_epopsadrh,
        ope_estts,
        ope_getsp,
        ope_setsp,
        ope_swp,
        ope_tnt,
        ope_vtt,
        ope_erqld,
        ope_erqldb,
        ope_jmpts,
        ope_jmptc,
        ope_muls,
        ope_neg,
        ope_negts,

        // udiv

        ope_udivinit,
        ope_udivgq,	
        ope_udivgr,	
        ope_udivgqh,	
        ope_udivgrh,	
        ope_udivsdd,	
        ope_udivsdv,	
        ope_udivsddh,
        ope_udivsdvh,
        ope_udivstep,

        // extension

        ope_exl2den,
        ope_exl2denerqld,
        ope_exl2derqld,

        // emulator

        ope_dexti

    }
}
