library ieee;
use work.hcore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity asr is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;
				
				-- 
				
				a					: in std_logic_vector(31 downto 0);	
				b					: in std_logic_vector(31 downto 0);	
				res				: out std_logic_vector(31 downto 0)	
			
		);
end entity;



architecture rtl of asr is
begin

	res <= std_logic_vector(SHR(signed(b),unsigned(a(4 downto 0))));

end rtl;
