library ieee;
use work.ucore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity logics is
		port 
		(			
				-- data in
				
				b					: in std_logic_vector(15 downto 0);
				a					: in std_logic_vector(15 downto 0);
							
				-- data out
				
				and_res			: out std_logic_vector(15 downto 0);
				or_res			: out std_logic_vector(15 downto 0);
				xor_res			: out std_logic_vector(15 downto 0);
				bic_res			: out std_logic_vector(15 downto 0)
			
															
		);
end entity;

architecture rtl of logics is
		
begin

	and_res 	<= b and a;
	or_res 	<= b or a;
	xor_res 	<= b xor a;
	bic_res 	<= b and not a;
			
end rtl;
